<?php

/**
 *  * You are allowed to use this API in your web application.
 *
 * Copyright (C) 2018 by customweb GmbH
 *
 * This program is licenced under the customweb software licence. With the
 * purchase or the installation of the software in your application you
 * accept the licence agreement. The allowed usage is outlined in the
 * customweb software licence which can be found under
 * http://www.sellxed.com/en/software-license-agreement
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at http://www.sellxed.com/shop.
 *
 * See the customweb software licence agreement for more details.
 *
 */

//require_once 'Customweb/Stripe/Method/Default.php';



/**
 *
 * @author Sebastian Bossert
 * @Method(paymentMethods={'bitcoin'})
 */
class Customweb_Stripe_Method_Bitcoin extends Customweb_Stripe_Method_Default {

	public function processPaymentInformation(Customweb_Stripe_Authorization_Transaction $transaction, array $json){
		$transaction->setBtcAmount(sprintf("%.8f", $json['bitcoin']['amount'] / 100000000)); // satoshi to btc conversion
		$transaction->setBtcReceiver($json['receiver']['address']);
		$transaction->setBtcUri($json['receiver']['uri']);
	}
}