/**
 * You are allowed to use this API in your web application.
 *
 * Copyright (C) 2018 by customweb GmbH
 *
 * This program is licenced under the customweb software licence. With the
 * purchase or the installation of the software in your application you
 * accept the licence agreement. The allowed usage is outlined in the
 * customweb software licence which can be found under
 * http://www.sellxed.com/en/software-license-agreement
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at http://www.sellxed.com/shop.
 *
 * See the customweb software licence agreement for more details.
 *
 *
 * @category	Customweb
 * @package		Customweb_StripeCw
 * 
 */

define([
	'uiComponent',
	'Magento_Checkout/js/model/payment/renderer-list'
], function(
	Component,
	rendererList
) {
	'use strict';
	
	rendererList.push(
			{
			    type: 'stripecw_creditcard',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_creditcard-method'
			},
			{
			    type: 'stripecw_visa',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_visa-method'
			},
			{
			    type: 'stripecw_mastercard',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_mastercard-method'
			},
			{
			    type: 'stripecw_americanexpress',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_americanexpress-method'
			},
			{
			    type: 'stripecw_diners',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_diners-method'
			},
			{
			    type: 'stripecw_jcb',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_jcb-method'
			},
			{
			    type: 'stripecw_discovercard',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_discovercard-method'
			},
			{
			    type: 'stripecw_ideal',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_ideal-method'
			},
			{
			    type: 'stripecw_sofortueberweisung',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_sofortueberweisung-method'
			},
			{
			    type: 'stripecw_giropay',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_giropay-method'
			},
			{
			    type: 'stripecw_directdebits',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_directdebits-method'
			},
			{
			    type: 'stripecw_bcmc',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_bcmc-method'
			},
			{
			    type: 'stripecw_przelewy24',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_przelewy24-method'
			},
			{
			    type: 'stripecw_alipay',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_alipay-method'
			},
			{
			    type: 'stripecw_btc',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_btc-method'
			},
			{
			    type: 'stripecw_stripepaymentrequest',
			    component: 'Customweb_StripeCw/js/view/payment/method-renderer/stripecw_stripepaymentrequest-method'
			});
	return Component.extend({});
});