<?php

/**
 *  * You are allowed to use this API in your web application.
 *
 * Copyright (C) 2018 by customweb GmbH
 *
 * This program is licenced under the customweb software licence. With the
 * purchase or the installation of the software in your application you
 * accept the licence agreement. The allowed usage is outlined in the
 * customweb software licence which can be found under
 * http://www.sellxed.com/en/software-license-agreement
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at http://www.sellxed.com/shop.
 *
 * See the customweb software licence agreement for more details.
 *
 */




/**
 *
 * @author sebastian
 *
 */
class Customweb_Stripe_Util {

	/**
	 * Encodes the given object as a javascript object, without quotation marks for properties.
	 *
	 * @param array $array
	 * @return string
	 */
	public static function simpleJSEncode(array $array){
		$js = "{";
		foreach ($array as $key => $value) {
			if (is_array($value)) {
				$value = self::simpleJSEncode($value);
			}
			else {
				$value = '"' . (string) $value . '"';
			}
			$js .= ' ' . $key . ': ' . $value . ',';
		}
		$js = rtrim($js, ",");
		return $js . " }";
	}
	
	public static function isZeroTransaction(Customweb_Stripe_Authorization_Transaction $transaction){
		return Customweb_Util_Currency::compareAmount($transaction->getAuthorizationAmount(), 0, $transaction->getCurrencyCode()) == 0 && $transaction->getTransactionContext()->createRecurringAlias();
	}
}